#!/usr/bin/python3
import json
import sys
import getopt
import yaml
import os

infile = sys.argv[1]
#read inventory template
i_tmpl='./templates/inventory.yml'

if (os.path.exists(sys.argv[2])):
  f = open(sys.argv[2],'r')
  nodes = yaml.full_load(f.read())
  f.close()
elif (os.path.exists(i_tmpl)):
  f = open(i_tmpl,'r')
  nodes = yaml.full_load(f.read())
  f.close()
if (nodes == ""):
  nodes = {'all':{'children':{'management':{'hosts':{}},'red':{'hosts':{}},'blue':{'hosts':{}}}}}
#Open json data state-file from Terraform
f = open(infile,"r")
data = f.read()
f.close()
dataj = json.loads(data)

#Create ansible inventory
for r in dataj['resources']:
  if (r['type']=='openstack_compute_instance_v2'):
    node={}
    group=''
    if (r['instances'][0]['attributes']['image_name'].find('Ubuntu')>=0):
      node['ansible_user']='ubuntu'
    if (r['instances'][0]['attributes']['image_name'].find('Debian')>=0):
      node['ansible_user']='debian'
    for net in r['instances'][0]['attributes']['network']:
      ip={}
      if (net['fixed_ip_v4'] != ''): ip['ipv4']=net['fixed_ip_v4']
      if (net['fixed_ip_v6'] != ''): ip['ipv6']=net['fixed_ip_v6']
      print(ip)
      node[net['name'].replace(" ","_")]=ip
      if (net['name'].find('mgmt')>=0):
        node['ansible_host']=ip['ipv4']
        group='management'
      if (r['name'] not in  nodes['all']['children'][group]['hosts']):
         nodes['all']['children'][group]['hosts'][r['name']]=node
      nodes['all']['children'][group]['hosts'][r['name']].update(node)
outfile = sys.argv[2]
#nodes['all']['children']['management']=nodes
print(nodes)

#nodes['all']['children']['management']['vars']={'ansible_ssh_private_key_file': './keys/id_rsa_mgmt'}
#Write ansible inventory
f = open(outfile,"w")

f.write(yaml.dump(nodes))
f.close()

