#!/bin/bash
PORT="/dev/ttyS0"
BAUD=115200
NIC=eth0
TFTPD_IP="192.168.1.2"


/bin/expect -c "
 set timeout -1
 exec stty -F $PORT $BAUD
 spawn -open [open $PORT w+]
 expect \"The boot is CFE\"
 send \\x03
 expect \"CFE>\"
 send_user \"got command line\\n\"
 exit 0"


#move tftp server to provisioning network
if [[ $(ip address show dev $NIC | grep "$TFPD_IP" | wc -c) -ne 0 ]]; then
  ip a add $TFTPD_IP/24 dev $NIC
fi

# start tftpd
echo start tftpd
atftpd --daemon --pidfile atftpd.pid tftproot

#boot from tftpd
/bin/expect -c "
 set timeout -1
 exec stty -F $PORT $BAUD
 spawn -open [open $PORT w+]
 send \"\\n\"
 expect \"CFE>\"
 send_user \"got command line\\n\"
 exit 0"

##clean up
#exit tftpd server
if [[ -e atftpd.pid ]]; then 
 kill $(cat atftpd.pid)
fi
#remove  ip
ip a del $TFTPD_IP/24 dev $NIC
#return to network

