#!/bin/bash

sudo apt-get update
sudo apt-get install ca-certificates curl gnupg lsb-release hostapd
curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg
echo \
  "deb [arch=$(dpkg --print-architecture) signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/ubuntu \
  $(lsb_release -cs) stable" | sudo tee /etc/apt/sources.list.d/docker.list > /dev/null
sudo apt-get update
sudo apt-get install docker-ce docker-ce-cli containerd.io docker-compose-plugin
mkdir /etc/homeassistant
sudo docker pull ghcr.io/home-assistant/home-assistant:stable
docker run -d \
  --name homeassistant \
  --privileged \
  --restart=unless-stopped \
  -e TZ=Europe/Oslo \
  -v /etc/homeassistant:/config \
  --network=host \
  --device=/dev/ttyUSB0 \ # connect the zigbee coordinator
  ghcr.io/home-assistant/home-assistant:stable
