#!/bin/bash
set -x
#File operations
chown keystone.keystone /etc/keystone/keystone.conf
chown neutron.neutron /etc/neutron -R
chown nova.nova /etc/nova/nova* -R

#Openstack Keystone
su -s /bin/sh -c "keystone-manage db_sync" keystone
keystone-manage fernet_setup --keystone-user keystone --keystone-group keystone
keystone-manage credential_setup --keystone-user keystone --keystone-group keystone
keystone-manage bootstrap --bootstrap-password XVvVYukd2dS1yGWUzIGV \
  --bootstrap-admin-url http://controller:5000/v3/ \
  --bootstrap-internal-url http://controller:5000/v3/ \
  --bootstrap-public-url http://controller:5000/v3/ \
  --bootstrap-region-id IoTCR
service apache2 restart

#Set environment variables for Openstack CLI
export OS_USERNAME=admin
export OS_PASSWORD=XVvVYukd2dS1yGWUzIGV
export OS_PROJECT_NAME=admin
export OS_USER_DOMAIN_NAME=Default
export OS_PROJECT_DOMAIN_NAME=Default
export OS_AUTH_URL=http://controller:5000/v3
export OS_IDENTITY_API_VERSION=3

#Openstack Placement
openstack user create --domain default --password CvKeJXiNzhpQIstla9I9 placement
openstack role add --project service --user placement admin
openstack service create --name placement --description "Placement API" placement
openstack endpoint create --region IoTCR placement public http://controller:8778
openstack endpoint create --region IoTCR placement internal http://controller:8778
openstack endpoint create --region IoTCR placement admin http://controller:8778

#Openstack Nova controller & compute
openstack user create --domain default --password NBy45nkIiySuM7HYVLXg nova
openstack role add --project service --user nova admin
openstack service create --name nova --description "OpenStack Compute" compute
openstack endpoint create --region IoTCR compute public http://controller:8774/v2.1
openstack endpoint create --region IoTCR compute internal http://controller:8774/v2.1
openstack endpoint create --region IoTCR compute admin http://controller:8774/v2.1

#Openstack Glance
openstack user create --domain default --password iWMlfGlH9qc7SmoIrtHg glance
openstack role add --project service --user glance admin
openstack service create --name glance --description "OpenStack Image" image
openstack endpoint create --region IoTCR image public http://controller:9292
openstack endpoint create --region IoTCR image internal http://controller:9292
openstack endpoint create --region IoTCR image admin http://controller:9292
su -s /bin/sh -c "glance-manage db_sync" glance

#Openstack Neutron controller
openstack user create --domain default --password vikEBuB8FZdHGhYGslfg neutron
openstack role add --project service --user neutron admin
openstack service create --name neutron --description "OpenStack Networking" network
openstack endpoint create --region IoTCR network public http://controller:9696
openstack endpoint create --region IoTCR network internal http://controller:9696
openstack endpoint create --region IoTCR network admin http://controller:9696
su -s /bin/sh -c "neutron-db-manage --config-file /etc/neutron/neutron.conf --config-file /etc/neutron/plugins/ml2/ml2_conf.ini upgrade head" neutron

#Openstack Ironic
openstack user create --password PJ6RLD7usMjdNuhYNoGn ironic
openstack role add --project service --user ironic admin
openstack service create --name ironic --description "Ironic baremetal provisioning service" baremetal
openstack endpoint create --region IoTCR baremetal admin http://controller:6385
openstack endpoint create --region IoTCR baremetal internal http://controller:6385
openstack endpoint create --region IoTCR baremetal public http://controller:6385
ironic-dbsync --config-file /etc/ironic/ironic.conf create_schema

