#!/bin/sh
chown nova.nova /etc/nova/*
chown neutron.neutron /etc/neutron/* -R
ovs-vsctl add-br br-ex



#FirmAE
git clone --recursive https://github.com/pr0v3rbs/FirmAE
cd FirmAE
./download.sh
./install.sh
./init.sh
./

#Download some firmwares
wget https://downloads.linksys.com/downloads/firmware/FW_E900_1.0.09.002_US_20180808.bin

wget https://download.vivotek.com/downloadfile/downloads/firmware/fe9180-hfirmware_beta.zip
unzip fe9180-hfirmware_beta.zip

wget https://download.vivotek.com/downloadfile/downloads/firmware/ms9321-ehvfirmware_1_2001.zip
unzip ms9321-ehvfirmware_1_2001.zip

#Create network bridge for firmware emulation
sudo docker network create -d macvlan -o parent=br-ex_blue docker_ex_blue
echo "1" > /proc/sys/net/ipv4/ip_forward

#Running firmware in docker while doing some NAT
./run_firmae FW_E900_1.0.09.002_US_20180808.bin

##Run ARM emulation with QEMU for running ARM images on OpenStack Nova
#https://futurewei-cloud.github.io/ARM-Datacenter/qemu/how-to-launch-aarch64-vm/
apt update
apt install -y qemu-system-arm qemu-efi-aarch64 qemu-utils qemu-system-mips qemu-system-ppc qemu-kvm openvswitch-switch
mkdir arm & cd arm
dd if=/dev/zero of=flash1.img bs=1M count=64
dd if=/dev/zero of=flash0.img bs=1M count=64
dd if=/usr/share/qemu-efi-aarch64/QEMU_EFI.fd of=flash0.img conv=notrunc
qemu-img create ubuntu-image.img 20G -f qcow2
wget http://ports.ubuntu.com/ubuntu-ports/dists/bionic-updates/main/installer-arm64/current/images/netboot/mini.iso

qemu-system-aarch64 -nographic -machine virt,gic-version=3 -m 512M -cpu cortex-a15 -smp 4 \
  -netdev user,id=vnet,hostfwd=:127.0.0.1:0-:22 -device virtio-net-pci,netdev=vnet \
  -drive file=ubuntu-image.img,if=none,id=drive0,cache=writeback -device virtio-blk,drive=drive0,bootindex=0 \
  -drive file=mini.iso,if=none,id=drive1,cache=writeback -device virtio-blk,drive=drive1,bootindex=1 \
  -drive file=flash0.img,format=raw,if=pflash -drive file=flash1.img,format=raw,if=pflash 
