#!/bin/bash

case $1 in 
start)
 sudo /usr/local/share/openvswitch/scripts/ovs-ctl restart --delete-bridges
 ovs-vsctl add-br br0
 ovs-vsctl add-br br-ex_red br0 41
 ovs-vsctl add-br br-ex_blue br0 42
 ovs-vsctl add-br br-ex_blue_dmz br0 43
 ovs-vsctl add-br br-ex_public br0 46
 ovs-vsctl add-br br-mgmt_prov br0 40
 ovs-vsctl add-br br-mgmt br0 3
 ovs-vsctl add-port br0 vxlan_sw1 -- set interface vxlan_os1 type=vxlan options:remote_ip=10.0.10.12 options:key=445

 ovs-vsctl add-port br-ex_blue docker_ex_blue -- set interface docker_ex_blue type=internal
 

#Blue team network
 ifconfig ens10 promisc
 ovs-vsctl add-port br-ex_blue ens10
 ifconfig ens8 promisc
 ovs-vsctl add-port br-ex_blue_dmz ens8
 ip address add 172.20.0.1/24 dev docker_ex_blue
 ip link set docker_ex_blue up

#Management
 ifconfig ens3 promisc
 ovs-vsctl add-port br-mgmt ens3
 ip address flush dev ens3
 ip address add 192.168.3.144/24 dev br-mgmt
 ip link set up dev br-mgmt
 ip -6 addr add 2001:700:1d00:ea0a:4898:feef:fe23:7b46/64 dev br-mgmt

#vlan
 ip address flush dev ens9
 ip address add 10.0.10.11/24 dev ens4

 ;;
stop)
 sudo /usr/local/share/openvswitch/scripts/ovs-ctl stop
 ip address add 192.168.3.144/24 dev ens3
 ;;
*)
 echo "$0 start|stop"
 ;;
esac

