#!/bin/bash
set -x
MAN=linksys_e900
FW=$1
IID=5
WPATH=~/FirmAE/scratch/$IID
INT_IP=`cat ${WPATH}/ip.0`
EXT_IP=172.11.12.33/24
NET=docker_ex_blue
PORTS=(23 80)

#sudo python3 ./docker-helper.py -ec $MAN $FW
sudo screen -d -m python3 ./docker-helper.py -ed $FW

CON=docker0_$FW

sleep 10

sudo ovs-docker add-port br-ex_blue eth3 $CON
sudo docker exec $CON ip link set up dev eth3
sudo docker exec $CON ip a add $EXT_IP dev eth3

for P in ${PORTS[@]}
do
 sudo docker exec $CON iptables -t nat -A PREROUTING -i eth3 -p tcp --dport $P -j DNAT --to-destination $INT_IP
 sudo docker exec $CON iptables -t nat -A POSTROUTING -o tap${IID}_0 -p tcp --dport $P -d $INT_IP -j SNAT --to-source `echo $INT_IP | awk '{print substr($1,1,length($1)-1)}'`2
done
sudo docker network disconnect bridge $CON
