#!/bin/bash
#set -x

case $1 in 
start)
 sudo /usr/local/share/openvswitch/scripts/ovs-ctl restart --delete-bridges
 ovs-vsctl add-br br0
 ovs-vsctl add-br br-ex_red br0 41
 ovs-vsctl add-br br-ex_blue br0 42
 ovs-vsctl add-br br-ex_blue_dmz br0 43
 ovs-vsctl add-br br-ex_public br0 46
 ovs-vsctl add-br br-mgmt_prov br0 40
 ovs-vsctl add-br br-mgmt br0 3
 ovs-vsctl add-port br0 vxlan_os1 -- set interface vxlan_os1 type=vxlan options:remote_ip=10.0.10.10 options:key=443
 ovs-vsctl add-port br0 vxlan_os2 -- set interface vxlan_os2 type=vxlan options:remote_ip=10.0.10.11 options:key=445
 ovs-vsctl add-port br0 vxlan_os3 -- set interface vxlan_os3 type=vxlan options:remote_ip=10.0.10.13 options:key=446
 ovs-vsctl add-port br0 vxlan_wg -- set interface vxlan_wg type=vxlan options:remote_ip=192.168.64.2 options:key=42

 ip address add 192.168.64.3/28 dev br0
 ip link set br0 up  

#Public network
 ifconfig ens7 promisc
 ovs-vsctl add-port br-ex_public ens7

#Red team network
 ifconfig ens4 promisc
 ovs-vsctl add-port br-ex_red ens4

#Blue team network
 ifconfig ens10 promisc
 ovs-vsctl add-port br-ex_blue ens10
 ifconfig ens8 promisc
 ovs-vsctl add-port br-ex_blue_dmz ens8
#ip address add 192.168.42.3/24 dev br-ex_blue
#ip link set bluebr up

#Management
 ifconfig ens3 promisc
 ovs-vsctl add-port br-mgmt ens3
 ip address flush dev ens3
 ip address add 192.168.3.211/24 dev br-mgmt
 ip link set up dev br-mgmt
 ip -6 addr add 2001:700:1d00:ea0a:4898:feef:fe23:7b46/64 dev br-mgmt

#vlan
 ip address flush dev ens9
 ip address add 10.0.10.12/24 dev ens9

#provision
 ifconfig ens5 promisc
 ovs-vsctl add-port br-mgmt_prov ens5
 ;;

stop)
 sudo /usr/local/share/openvswitch/scripts/ovs-ctl stop
 ip address add 192.168.3.210/24 dev ens3
 ;;
*)
 echo "$0 start|stop"
 ;;
esac

