#!/bin/bash
#/usr/local/share/openvswitch/scripts/ovs-ctl start --delete-bridges
apt install wireguard make automake autoconf gcc
mkdir /opt/openvswitch
cd /opt/openvswitch
wget https://www.openvswitch.org/releases/openvswitch-2.16.1.tar.gz
tar zxvf openvswitch-2.16.1.tar.gz
cd openvswitch-2.16.1
./configure
make
make install

find_iface(){
 IFACE=$(ip a | grep ^[0-9]*:[[:space:]] -E3 |\
  awk '/^[0-9]+:[[:space:]]/ { nic = substr($2,0,length($2)-1) } /inet/ {print nic " " $2}' | \
  grep $IP | \
  awk '{print $1}')
}
#create main bridge
ovs-vsctl add-br br0
#create management bridge
IP=192.168.3.87
find_iface
BR=br-mgmt
VLAN=3
ovs-vsctl add-br br-mgmt br0 3
ip link set $BR up
ip address add $IP/24 dev $BR

#create provisioning bridge
VLAN=40
BR=br-prov
ovs-vsctl add-br $BR br0 $VLAN

#create red team bridge
ovs-vsctl add-br br_red br0 41

#create blue team bridge
ovs-vsctl add-br br_blue br0 42
ovs-vsctl add-br br-management br0 3

ovs-vsctl add-port br0 vxlan_sw1 -- set interface vxlan_sw1 type=vxlan options:remote_ip=192.168.64.1 options:key=442
#ovs-vsctl add-port br0 vxlan_os1 -- set interface vxlan_os1 type=vxlan options:remote_ip=10.0.10.10 options:key=443
#ovs-vsctl add-port br0 vxlan_os2 -- set interface vxlan_os2 type=vxlan options:remote_ip=10.0.10.11 options:key=445
#ovs-vsctl add-port br0 vxlan_os3 -- set interface vxlan_os3 type=vxlan options:remote_ip=10.0.10.13 options:key=446

#ip address add 192.168.64.3/28 dev br0
#ip link set br0 up
#ipconfig ens7 promisc
#ipconfig ens8 promisc
#ovs-vsctl add-port redbr ens7
#ovs-vsctl add-port bluebr ens8
#ip address add 192.168.42.3/24 dev bluebr
#ip link set bluebr up

#enable wireguard
systemctl enable wg-quick@wg0.service
systemctl daemon-reload
systemctl start wg-quick@wg0


#Install whsniff Zigbee packet sniffer
apt-get -y install libusb-1.0-0-dev wireshark unzip p7zip-full cc-tool
wget https://www.ti.com/lit/zip/swrc045 -O swrc045z.zip
unzip swrc045z.zip -d PACKET-SNIFFER
7z e PACKET-SNIFFER/Setup_SmartRF_Packet_Sniffer_2.18.0.exe bin/general/firmware/sniffer_fw_cc2531.hex
curl -L https://github.com/homewsn/whsniff/archive/v1.3.tar.gz | tar zx
cd whsniff-1.3
make
sudo make install
