#!/bin/bash
#/usr/local/share/openvswitch/scripts/ovs-ctl start --delete-bridges
find_iface(){
 IFACE=$(ip a | grep ^[0-9]*:[[:space:]] -E3 |\
  awk '/^[0-9]+:[[:space:]]/ { nic = substr($2,0,length($2)-1) } /inet/ {print nic " " $2}' | \
  grep $IP | \
  awk '{print $1}')
}
#create main bridge
ovs-vsctl add-br br0
#create management bridge
IP={{hostvars['switch1'].ansible_host}}
find_iface
BR=br-mgmt
VLAN=3
ovs-vsctl add-br $BR br0 $VLAN
ip link set $BR up
ovs-vsctl add-port $BR $IFACE && ip address add $IP/24 dev $BR && ip address delete $IP/24 dev $IFACE
ip route add default via 10.0.9.1
#create provisioning bridge
IP={{hostvars['switch1'].skyhigh_provisioning_network.ipv4}}
VLAN=40
BR=br-prov
find_iface
ovs-vsctl add-br $BR br0 $VLAN
ovs-vsctl add-port $BR $IFACE
ip address delete $IP/24 dev $IFACE

#create red team bridge
ovs-vsctl add-br br_red br0 41

#create blue team bridge
ovs-vsctl add-br br_blue br0 42
#ovs-vsctl add-br br-management br0 3

#ovs-vsctl add-port br0 vxlan_sw2 -- set interface vxlan_sw2 type=vxlan options:remote_ip=192.168.64.2 options:key=442
#ovs-vsctl add-port br0 vxlan_os1 -- set interface vxlan_os1 type=vxlan options:remote_ip=10.0.10.10 options:key=443
#ovs-vsctl add-port br0 vxlan_os2 -- set interface vxlan_os2 type=vxlan options:remote_ip=10.0.10.11 options:key=445
#ovs-vsctl add-port br0 vxlan_os3 -- set interface vxlan_os3 type=vxlan options:remote_ip=10.0.10.13 options:key=446

#ip address add 192.168.64.3/28 dev br0
#ip link set br0 up
#ipconfig ens7 promisc
#ipconfig ens8 promisc
#ovs-vsctl add-port redbr ens7
#ovs-vsctl add-port bluebr ens8
#ip address add 192.168.42.3/24 dev bluebr
#ip link set bluebr up

#enable wireguard
systemctl enable wg-quick@wg0.service
systemctl daemon-reload
systemctl start wg-quick@wg0

